#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "acpp.h"

extern	int getopt(int, char *const *, const char *);
extern	char	*optarg;
extern	int	optind;
extern	int	verbose;
extern	int	Cplusplus;
Nlist	*kwdefined;
char	wd[128];

void setup_kwtab(void);

#define	NLSIZE	128

static Nlist	*nlist[NLSIZE];

struct	kwtab {
	char	*kw;
	int	val;
	int	flag;
} kwtab[] = {
	{ "co",		KCO,		ISKW }, /* RSE: Add comment control directive */
	{ "if",		KIF,		ISKW },
	{ "ifdef",	KIFDEF,		ISKW },
	{ "ifndef",	KIFNDEF,	ISKW },
	{ "elif",		KELIF,		ISKW },
	{ "else",		KELSE,		ISKW },
	{ "endif",	KENDIF,		ISKW },
	{ "include",	KINCLUDE,	ISKW },
	{ "define",	KDEFINE,	ISKW },
	{ "undef",	KUNDEF,		ISKW },
	{ "line",		KLINE,		ISKW },
	{ "error",	KERROR,		ISKW },
	{ "pragma",	KPRAGMA,	ISKW },
	{ "eval",		KEVAL,		ISKW },
	{ "defined",	KDEFINED,	ISDEFINED+ISUNCHANGE },
	{ "__LINE__",	KLINENO,	ISMAC+ISUNCHANGE },
	{ "__FILE__",	KFILE,		ISMAC+ISUNCHANGE },
	{ "__DATE__",	KDATE,		ISMAC+ISUNCHANGE },
	{ "__TIME__",	KTIME,		ISMAC+ISUNCHANGE },
	{ "__STDC__",	KSTDC,		ISUNCHANGE },
	{ NULL }
};

unsigned long	namebit[077+1];
Nlist 	*np;

void
setup_kwtab(void)
{
	struct kwtab *kp;
	Nlist *mynp;
	Token t;
	static Token deftoken[1] = {{ NAME, 0, 0, 0, 7, (uchar*)"defined" }};
	static Tokenrow deftr = { deftoken, deftoken, deftoken+1, 1 };

	for (kp=kwtab; kp->kw; kp++) {
		t.t = (uchar*)kp->kw;
		t.len = strlen(kp->kw);
		mynp = lookup(&t, 1);
		mynp->flag = kp->flag;
		mynp->val = kp->val;
		if (mynp->val == KDEFINED) {
			kwdefined = mynp;
			mynp->val = NAME;
			mynp->vp = &deftr;
			mynp->ap = 0;
		}
	}
}

Nlist *
lookup(Token *tp, int install)
{
	unsigned int h;
	Nlist *mynp;
	uchar *cp, *cpe;

	h = 0;
	for (cp=tp->t, cpe=cp+tp->len; cp<cpe; )
		h += *cp++;
	h %= NLSIZE;
	mynp = nlist[h];
	while (mynp) {
		if (*tp->t==*mynp->name && tp->len==mynp->len 
		 && strncmp((char*)tp->t, (char*)mynp->name, tp->len)==0)
			return mynp;
		mynp = mynp->next;
	}
	if (install) {
		mynp = new(Nlist);
		mynp->vp = NULL;
		mynp->ap = NULL;
		mynp->flag = 0;
		mynp->val = 0;
		mynp->len = tp->len;
		mynp->name = newstring(tp->t, tp->len, 0);
		mynp->next = nlist[h];
		nlist[h] = mynp;
		quickset(tp->t[0], tp->len>1? tp->t[1]:0);
		return mynp;
	}
	return NULL;
}
